// stristr.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
char* strstr2(char* str1, char* str2);
char* stristr(char* str1, char* str2);
LPTSTR LookupNaive(LPTSTR str1, LPTSTR str2);



int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{


// single test
	char* s = stristr("AbC","Bc"); // performs a case-insensitive find of "Bc" in "AbC"

	LPTSTR s2 = LookupNaive("ABC","Bc");


// test suite

	TCHAR buffer[100000];

	// fill the buffer from a sample file
	HANDLE fin = ::CreateFile("USERCTRL.htm",GENERIC_READ,FILE_SHARE_READ,NULL,
							OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (fin == INVALID_HANDLE_VALUE)
	{
		fin = ::CreateFile("..\\USERCTRL.htm",GENERIC_READ,FILE_SHARE_READ,NULL,
							OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
		if (fin == INVALID_HANDLE_VALUE)
		{
			::MessageBox(NULL,"file not found","error",MB_OK);
			return 0;
		}
	}

	DWORD indexin = 0;
	DWORD dwRead = 0;
	::ReadFile(fin,buffer+indexin,4096,&dwRead,NULL);
	while ( dwRead > 0 )
	{
		indexin += dwRead;
		dwRead = 0;
		::ReadFile(fin,buffer+indexin,4096,&dwRead,NULL);
	}

	::CloseHandle(fin);



	DWORD dwStart, dwEnd, dwElapsed, secs;
	DWORD dwElapsed1, dwElapsed2, dwElapsed3, dwElapsed4;
	long nbtimes = 10000, i;
	TCHAR sztmp[128];


	//
	// play with C run-time strstr a given amount of times
	//

	dwStart = ::GetTickCount();

	for (i = 0; i < nbtimes; i++)
	{
		LPTSTR p = buffer;
		LPTSTR q = NULL;
		while ( (q=strstr(p,"developer")) ) // "developer" appears 14 times
			p = q + 1;
	}

	dwEnd = ::GetTickCount();

	dwElapsed = dwEnd - dwStart;
	dwElapsed1 = dwElapsed;
	secs = dwElapsed / 1000;

	
	_stprintf(sztmp,"duration for %s test suite : %d msecs\r\n", "C run-time strstr", dwElapsed);
	::OutputDebugString(sztmp);

	//
	// play with personal strstr a given amount of times
	//

	dwStart = ::GetTickCount();

	for (i = 0; i < nbtimes; i++)
	{
		LPTSTR p = buffer;
		LPTSTR q = NULL;
		while ( (q=strstr2(p,"developer")) ) // "developer" appears 14 times
			p = q + 1;
	}

	dwEnd = ::GetTickCount();

	dwElapsed = dwEnd - dwStart;
	dwElapsed2 = dwElapsed;
	secs = dwElapsed / 1000;

	
	_stprintf(sztmp,"duration for %s test suite : %d msecs\r\n", "personal strstr", dwElapsed);
	::OutputDebugString(sztmp);


	//
	// play with personal stristr a given amount of times
	//

	dwStart = ::GetTickCount();

	for (i = 0; i < nbtimes; i++)
	{
		LPTSTR p = buffer;
		LPTSTR q = NULL;
		while ( (q=stristr(p,"developer")) ) // "developer" appears 14 times
			p = q + 1;
	}

	dwEnd = ::GetTickCount();

	dwElapsed = dwEnd - dwStart;
	dwElapsed3 = dwElapsed;
	secs = dwElapsed / 1000;

	
	_stprintf(sztmp,"duration for %s test suite : %d msecs\r\n", "personal stristr", dwElapsed);
	::OutputDebugString(sztmp);



	//
	// play with personal naive lookup (by hand) a given amount of times
	//

	dwStart = ::GetTickCount();

	for (i = 0; i < nbtimes; i++)
	{
		LPTSTR p = buffer;
		LPTSTR q = NULL;
		while ( (q=LookupNaive(p,"developer")) ) // "developer" appears 14 times
			p = q + 1;
	}

	dwEnd = ::GetTickCount();

	dwElapsed = dwEnd - dwStart;
	dwElapsed4 = dwElapsed;
	secs = dwElapsed / 1000;

	
	_stprintf(sztmp,"duration for %s test suite : %d msecs\r\n", "personal stristr", dwElapsed);
	::OutputDebugString(sztmp);



	_stprintf(sztmp,"duration = (%d ms, %d ms, %d ms, %d ms)\r\n", dwElapsed1, dwElapsed2, dwElapsed3, dwElapsed4);
	::MessageBox(NULL,sztmp,"performance",MB_OK);

	return FALSE;

}


// naive stristr using one-by-one character lookup

LPTSTR LookupNaive(LPTSTR str1, LPTSTR str2)
{
	if (!str1 || !str2)
		return NULL;

	if (*str2 == 0)
		return str1;

	LPTSTR p = str1;
	LPTSTR q = str2;
	TCHAR pc, qc;
	BOOL bBroken;

	while ( *p != 0) // outer loop
	{
		LPTSTR pold = p;
		bBroken = FALSE;

		do // inner loop
		{
			pc = *p;

			if (pc >='A' && pc <='Z')
				pc += 'a' - 'A';

			if (pc == 0)
				return NULL; // not found

			qc = *(q++);

			if (qc >='A' && qc <='Z')
				qc += 'a' - 'A';

			if (pc != qc)
			{
				p = pold + 1;
				bBroken = TRUE;
				break;
			}
			else
			{
				p++;
			}
		}
		while( *q != 0 );

		if (!bBroken)
			return pold;
		
		q = str2; // loop everything again
	}

	return NULL;
}


//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_STRISTR);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_STRISTR;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
